#define OSDynLoad_Acquire ((void (*)(char* rpl, unsigned int *handle))0x1026e60)
#define OSDynLoad_FindExport ((void (*)(unsigned int handle, int isdata, char *symbol, void *address))0x1028460)
#define OSFatal ((void (*)(char* msg))0x0102D01C)
#define __os_snprintf ((int(*)(char* s, int n, const char * format, ... ))0x102b9ac)

#define AF_INET		2
#define SOCK_STREAM	1
#define IPPROTO_TCP	6

struct in_addr
{
  unsigned long s_addr;
};

struct sockaddr
{
  unsigned short sin_family;
  unsigned short sin_port;
  struct in_addr sin_addr;
  char sin_zero[8];
};

/* IP address of the RPC client (in this case, 192.168.1.3) */
#define PC_IP	0xC0A80103

void start()
{
  /* Get a handle to nsysnet.rpl */
  unsigned int nsysnet_handle;
  OSDynLoad_Acquire("nsysnet.rpl", &nsysnet_handle);

  /* Socket functions */
  int (*socket)(int family, int type, int proto);
  int (*connect)(int fd, struct sockaddr *addr, int addrlen);
  int (*recv)(int fd, void *buffer, int len, int flags);
  int (*send)(int fd, const void *buffer, int len, int flags);

  /* Read the addresses of socket(), connect(), and send() */
  OSDynLoad_FindExport(nsysnet_handle, 0, "socket", &socket);
  OSDynLoad_FindExport(nsysnet_handle, 0, "connect", &connect);
  OSDynLoad_FindExport(nsysnet_handle, 0, "recv", &recv);
  OSDynLoad_FindExport(nsysnet_handle, 0, "send", &send);

  /* Set up our socket address structure */
  struct sockaddr sin;
  sin.sin_family = AF_INET;
  sin.sin_port = 12345;
  sin.sin_addr.s_addr = PC_IP;
  int i;
  for (i = 0; i < 8; i++)
  {
    sin.sin_zero[i] = 0;
  }

  /* Connect to the PC */
  int rpc = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
  int status = connect(rpc, &sin, 0x10);

  /* Block waiting for data */
  unsigned int buffer[128];
  while(1)
  {
    /* Get data from the socket */
    int bytes_read = recv(rpc, buffer, 512, 0);

	/* Look at the command byte */
	switch (buffer[0])
	{
	/* Read memory */
	case 0: ;
	  /* Copy them into the buffer */
	  unsigned int *src = (unsigned int*) buffer[1];
	  unsigned int *dest = &buffer[1];
	  unsigned int num_words = buffer[2];

	  for (i = 0; i < num_words; i++)
	  {
	    dest[i] = src[i];
	  }

	  /* Send the buffer back */
	  send(rpc, buffer, 512, 0);

	  break;
	/* Write memory */
	case 1: ;
	  /* Copy them into the buffer */
	  src = &buffer[3];
	  dest = (unsigned int*) buffer[1];
	  num_words = buffer[2];

	  for (i = 0; i < num_words; i++)
	  {
	    dest[i] = src[i];
	  }

	  break;
	/* Get symbol /
	case 2: ;
	  /* Identify the RPL name and symbol name /
	  char *rplname = (char*) &buffer[3];
	  char *symname = (char*) ((unsigned char*)&buffer[0]) + buffer[2];

	  OSFatal(rplname);

	  break;*/
	default:
	  OSFatal("Invalid RPC command");
	}
  }
}
